Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 4292)
@@ -20,4 +20,5 @@
    USE dom_oce         ! ocean space and time domain variables 
    USE bdy_oce         ! ocean open boundary conditions
+   USE bdylib          ! for orlanski library routines
    USE bdydta, ONLY:   bf
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
@@ -51,14 +52,18 @@
       DO ib_bdy=1, nb_bdy
 
-         SELECT CASE( nn_tra(ib_bdy) )
-         CASE(jp_none)
+         SELECT CASE( cn_tra(ib_bdy) )
+         CASE('none')
             CYCLE
-         CASE(jp_frs)
+         CASE('frs')
             CALL bdy_tra_frs( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
-         CASE(2)
+         CASE('specified')
             CALL bdy_tra_spe( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
-         CASE(3)
+         CASE('neumann')
             CALL bdy_tra_nmn( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
-         CASE(4)
+         CASE('orlanski')
+            CALL bdy_tra_orlanski( idx_bdy(ib_bdy), dta_bdy(ib_bdy), ll_npo=.false. )
+         CASE('orlanski_npo')
+            CALL bdy_tra_orlanski( idx_bdy(ib_bdy), dta_bdy(ib_bdy), ll_npo=.true. )
+         CASE('runoff')
             CALL bdy_tra_rnf( idx_bdy(ib_bdy), dta_bdy(ib_bdy), kt )
          CASE DEFAULT
@@ -196,4 +201,38 @@
       !
    END SUBROUTINE bdy_tra_nmn
+ 
+
+   SUBROUTINE bdy_tra_orlanski( idx, dta, ll_npo )
+      !!----------------------------------------------------------------------
+      !!                 ***  SUBROUTINE bdy_tra_orlanski  ***
+      !!             
+      !!              - Apply Orlanski radiation to temperature and salinity. 
+      !!              - Wrapper routine for bdy_orlanski_3d
+      !! 
+      !!
+      !! References:  Marchesiello, McWilliams and Shchepetkin, Ocean Modelling vol. 3 (2001)    
+      !!----------------------------------------------------------------------
+      TYPE(OBC_INDEX),              INTENT(in) ::   idx  ! OBC indices
+      TYPE(OBC_DATA),               INTENT(in) ::   dta  ! OBC external data
+      LOGICAL,                      INTENT(in) ::   ll_npo  ! switch for NPO version
+
+      INTEGER  ::   igrd                                    ! grid index
+      !!----------------------------------------------------------------------
+
+      IF( nn_timing == 1 ) CALL timing_start('bdy_tra_orlanski')
+      !
+      igrd = 1      ! Orlanski bc on temperature; 
+      !            
+      CALL bdy_orlanski_3d( idx, igrd, tsb(:,:,:,jp_tem), tsa(:,:,:,jp_tem), dta%tem, ll_npo )
+
+      igrd = 1      ! Orlanski bc on salinity;
+      !  
+      CALL bdy_orlanski_3d( idx, igrd, tsb(:,:,:,jp_sal), tsa(:,:,:,jp_sal), dta%sal, ll_npo )
+      !
+      IF( nn_timing == 1 ) CALL timing_stop('bdy_tra_orlanski')
+      !
+
+   END SUBROUTINE bdy_tra_orlanski
+
 
    SUBROUTINE bdy_tra_rnf( idx, dta, kt )
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdyvol.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdyvol.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/BDY/bdyvol.F90	(revision 4292)
@@ -104,5 +104,5 @@
                ii = idx%nbi(jb,jgrd)
                ij = idx%nbj(jb,jgrd)
-               zubtpecor = zubtpecor + idx%flagu(jb) * ua(ii,ij, jk) * e2u(ii,ij) * fse3u(ii,ij,jk)
+               zubtpecor = zubtpecor + idx%flagu(jb,jgrd) * ua(ii,ij, jk) * e2u(ii,ij) * fse3u(ii,ij,jk)
             END DO
          END DO
@@ -112,5 +112,5 @@
                ii = idx%nbi(jb,jgrd)
                ij = idx%nbj(jb,jgrd)
-               zubtpecor = zubtpecor + idx%flagv(jb) * va(ii,ij, jk) * e1v(ii,ij) * fse3v(ii,ij,jk) 
+               zubtpecor = zubtpecor + idx%flagv(jb,jgrd) * va(ii,ij, jk) * e1v(ii,ij) * fse3v(ii,ij,jk) 
             END DO
          END DO
@@ -136,6 +136,6 @@
                ii = idx%nbi(jb,jgrd)
                ij = idx%nbj(jb,jgrd)
-               ua(ii,ij,jk) = ua(ii,ij,jk) - idx%flagu(jb) * zubtpecor * umask(ii,ij,jk)
-               ztranst = ztranst + idx%flagu(jb) * ua(ii,ij,jk) * e2u(ii,ij) * fse3u(ii,ij,jk)
+               ua(ii,ij,jk) = ua(ii,ij,jk) - idx%flagu(jb,jgrd) * zubtpecor * umask(ii,ij,jk)
+               ztranst = ztranst + idx%flagu(jb,jgrd) * ua(ii,ij,jk) * e2u(ii,ij) * fse3u(ii,ij,jk)
             END DO
          END DO
@@ -145,6 +145,6 @@
                ii = idx%nbi(jb,jgrd)
                ij = idx%nbj(jb,jgrd)
-               va(ii,ij,jk) = va(ii,ij,jk) -idx%flagv(jb) * zubtpecor * vmask(ii,ij,jk)
-               ztranst = ztranst + idx%flagv(jb) * va(ii,ij,jk) * e1v(ii,ij) * fse3v(ii,ij,jk)
+               va(ii,ij,jk) = va(ii,ij,jk) -idx%flagv(jb,jgrd) * zubtpecor * vmask(ii,ij,jk)
+               ztranst = ztranst + idx%flagv(jb,jgrd) * va(ii,ij,jk) * e1v(ii,ij) * fse3v(ii,ij,jk)
             END DO
          END DO
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 4292)
@@ -196,6 +196,6 @@
       thick0(:,:) = 0._wp
       DO jk = 1, jpkm1
-         vol0        = vol0        + SUM( area (:,:) * tmask(:,:,jk) * fse3t_0(:,:,jk) )
-         thick0(:,:) = thick0(:,:) +    tmask_i(:,:) * tmask(:,:,jk) * fse3t_0(:,:,jk)
+         vol0        = vol0        + SUM( area (:,:) * tmask(:,:,jk) * e3t_0(:,:,jk) )
+         thick0(:,:) = thick0(:,:) +    tmask_i(:,:) * tmask(:,:,jk) * e3t_0(:,:,jk)
       END DO
       IF( lk_mpp )   CALL mpp_sum( vol0 )
@@ -212,5 +212,5 @@
                ik = mbkt(ji,jj)
                IF( ik > 1 ) THEN
-                  zztmp = ( gdept_0(ik) - fsdept_0(ji,jj,ik) ) / ( gdept_0(ik) - gdept_0(ik-1) )
+                  zztmp = ( gdept_1d(ik) - gdept_0(ji,jj,ik) ) / ( gdept_1d(ik) - gdept_1d(ik-1) )
                   sn0(ji,jj,ik) = ( 1._wp - zztmp ) * sn0(ji,jj,ik) + zztmp * sn0(ji,jj,ik-1)
                ENDIF
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90	(revision 4292)
@@ -112,8 +112,8 @@
 
     CASE ( 'T')
-       z4dep(:)=gdept_0(:)
+       z4dep(:)=gdept_1d(:)
 
     CASE ( 'W' )
-       z4dep(:)=gdepw_0(:)
+       z4dep(:)=gdepw_1d(:)
 
     CASE ( '2' )
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diaharm.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diaharm.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diaharm.F90	(revision 4292)
@@ -1,16 +1,16 @@
 MODULE diaharm 
-
-#if defined key_diaharm && defined key_tide
-   !!=================================================================================
+   !!======================================================================
    !!                       ***  MODULE  diaharm  ***
    !! Harmonic analysis of tidal constituents 
-   !!=================================================================================
-   !! * Modules used
+   !!======================================================================
+   !! History :  3.1  !  2007  (O. Le Galloudec, J. Chanut)  Original code
+   !!----------------------------------------------------------------------
+#if defined key_diaharm && defined key_tide
+   !!----------------------------------------------------------------------
+   !!   'key_diaharm'
+   !!   'key_tide'
+   !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain
-   USE in_out_manager  ! I/O units
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE ioipsl          ! NetCDF IPSL library
-   USE diadimg         ! To write dimg
    USE phycst
    USE dynspg_oce
@@ -18,5 +18,9 @@
    USE daymod
    USE tide_mod
-   USE iom 
+   USE in_out_manager  ! I/O units
+   USE iom             ! I/0 library
+   USE ioipsl          ! NetCDF IPSL library
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE diadimg         ! To write dimg
    USE timing          ! preformance summary
    USE wrk_nemo        ! working arrays
@@ -30,36 +34,32 @@
    INTEGER, PARAMETER :: jpdimsparse  = jpincomax*300*24
 
-   INTEGER ::                            & !! namelist variables
-                         nit000_han    , & ! First time step used for harmonic analysis
-                         nitend_han    , & ! Last time step used for harmonic analysis
-                         nstep_han     , & ! Time step frequency for harmonic analysis
-                         nb_ana            ! Number of harmonics to analyse
-
-   INTEGER , ALLOCATABLE, DIMENSION(:)       :: name
-   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) :: ana_temp
-   REAL(wp), ALLOCATABLE, DIMENSION(:)       :: ana_freq, vt, ut, ft
-   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   :: out_eta, &
-                                                out_u  , &
-                                                out_v
-
-   INTEGER :: ninco, nsparse
-   INTEGER ,       DIMENSION(jpdimsparse)         :: njsparse, nisparse
-   INTEGER , SAVE, DIMENSION(jpincomax)           :: ipos1
-   REAL(wp),       DIMENSION(jpdimsparse)         :: valuesparse
-   REAL(wp),       DIMENSION(jpincomax)           :: ztmp4 , ztmp7
-   REAL(wp), SAVE, DIMENSION(jpincomax,jpincomax) :: ztmp3 , zpilier
-   REAL(wp), SAVE, DIMENSION(jpincomax)           :: zpivot
-
-   CHARACTER (LEN=4), DIMENSION(jpmax_harmo) ::   &
-       tname         ! Names of tidal constituents ('M2', 'K1',...)
-
-
-!! * Routine accessibility
-   PUBLIC  dia_harm    ! routine called by step.F90
-
-   !!---------------------------------------------------------------------------------
-   !!  
-   !!---------------------------------------------------------------------------------
-
+   !                            !!!namelist variables
+   INTEGER ::   nit000_han    ! First time step used for harmonic analysis
+   INTEGER ::   nitend_han    ! Last time step used for harmonic analysis
+   INTEGER ::   nstep_han     ! Time step frequency for harmonic analysis
+   INTEGER ::   nb_ana           ! Number of harmonics to analyse
+
+   INTEGER , ALLOCATABLE, DIMENSION(:)       ::   name
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::   ana_temp
+   REAL(wp), ALLOCATABLE, DIMENSION(:)       ::   ana_freq, ut   , vt   , ft
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:)   ::   out_eta , out_u, out_v
+
+   INTEGER ::   ninco, nsparse
+   INTEGER ,       DIMENSION(jpdimsparse)         ::   njsparse, nisparse
+   INTEGER , SAVE, DIMENSION(jpincomax)           ::   ipos1
+   REAL(wp),       DIMENSION(jpdimsparse)         ::   valuesparse
+   REAL(wp),       DIMENSION(jpincomax)           ::   ztmp4 , ztmp7
+   REAL(wp), SAVE, DIMENSION(jpincomax,jpincomax) ::   ztmp3 , zpilier
+   REAL(wp), SAVE, DIMENSION(jpincomax)           ::   zpivot
+
+   CHARACTER (LEN=4), DIMENSION(jpmax_harmo) ::   tname   ! Names of tidal constituents ('M2', 'K1',...)
+
+   PUBLIC   dia_harm   ! routine called by step.F90
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.5 , NEMO Consortium (2013)
+   !! $Id:$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -67,5 +67,4 @@
       !!----------------------------------------------------------------------
       !!                 ***  ROUTINE dia_harm_init  ***
-      !!----------------------------------------------------------------------
       !!         
       !! ** Purpose :   Initialization of tidal harmonic analysis
@@ -73,8 +72,5 @@
       !! ** Method  :   Initialize frequency array and  nodal factor for nit000_han
       !!
-      !! History :
-      !!   9.0  O. Le Galloudec and J. Chanut (Original)
-      !!--------------------------------------------------------------------
-      !! * Local declarations 
+      !!--------------------------------------------------------------------
       INTEGER :: jh, nhan, jk, ji
       INTEGER ::   ios                 ! Local integer output status for namelist read
@@ -108,21 +104,13 @@
       ! Basic checks on harmonic analysis time window:
       ! ----------------------------------------------
-      IF (nit000 > nit000_han) THEN
-        IF(lwp) WRITE(numout,*) ' E R R O R dia_harm_init : nit000_han must be greater than nit000, stop'
-        IF(lwp) WRITE(numout,*) ' restart capability not implemented'
-        nstop = nstop + 1
-      ENDIF
-      IF (nitend < nitend_han) THEN
-        IF(lwp) WRITE(numout,*) ' E R R O R dia_harm_init : nitend_han must be lower than nitend, stop'
-        IF(lwp) WRITE(numout,*) ' restart capability not implemented'
-        nstop = nstop + 1
-      ENDIF
-
-      IF (MOD(nitend_han-nit000_han+1,nstep_han).NE.0) THEN
-        IF(lwp) WRITE(numout,*) ' E R R O R dia_harm_init : analysis time span must be a multiple of nstep_han, stop'
-        nstop = nstop + 1
-      END IF
-
-      nb_ana=0
+      IF( nit000 > nit000_han )   CALL ctl_stop( 'dia_harm_init : nit000_han must be greater than nit000',   &
+         &                                       ' restart capability not implemented' )
+      IF( nitend < nitend_han )   CALL ctl_stop( 'dia_harm_init : nitend_han must be lower than nitend',   &
+         &                                       'restart capability not implemented' )
+
+      IF( MOD( nitend_han-nit000_han+1 , nstep_han ) /= 0 )   &
+         &                        CALL ctl_stop( 'dia_harm_init : analysis time span must be a multiple of nstep_han' )
+
+      nb_ana = 0
       DO jk=1,jpmax_harmo
          DO ji=1,jpmax_harmo
@@ -157,10 +145,7 @@
       ! Initialize frequency array:
       ! ---------------------------
-      ALLOCATE(ana_freq(nb_ana))
-      ALLOCATE(vt      (nb_ana))
-      ALLOCATE(ut      (nb_ana))
-      ALLOCATE(ft      (nb_ana))
-
-      CALL tide_harmo(ana_freq, vt, ut , ft, name ,nb_ana)
+      ALLOCATE( ana_freq(nb_ana), ut(nb_ana), vt(nb_ana), ft(nb_ana) )
+
+      CALL tide_harmo( ana_freq, vt, ut, ft, name, nb_ana )
 
       IF(lwp) WRITE(numout,*) 'Analysed frequency  : ',nb_ana ,'Frequency '
@@ -172,13 +157,13 @@
       ! Initialize temporary arrays:
       ! ----------------------------
-      ALLOCATE( ana_temp(jpi,jpj,nb_ana*2,3))
+      ALLOCATE( ana_temp(jpi,jpj,2*nb_ana,3) )
       ana_temp(:,:,:,:) = 0.e0
 
    END SUBROUTINE dia_harm_init
-   
+
+
    SUBROUTINE dia_harm ( kt )
       !!----------------------------------------------------------------------
       !!                 ***  ROUTINE dia_harm  ***
-      !!----------------------------------------------------------------------
       !!         
       !! ** Purpose :   Tidal harmonic analysis main routine
@@ -186,11 +171,7 @@
       !! ** Action  :   Sums ssh/u/v over time analysis [nit000_han,nitend_han]
       !!
-      !! History :
-      !!   9.0  O. Le Galloudec and J. Chanut (Original)
-      !!--------------------------------------------------------------------
-      !! * Argument:
+      !!--------------------------------------------------------------------
       INTEGER, INTENT( IN ) :: kt
-
-      !! * Local declarations
+      !
       INTEGER  :: ji, jj, jh, jc, nhc
       REAL(wp) :: ztime, ztemp
@@ -198,5 +179,5 @@
       IF( nn_timing == 1 )   CALL timing_start('dia_harm')
 
-      IF ( kt .EQ. nit000 ) CALL dia_harm_init
+      IF ( kt == nit000 ) CALL dia_harm_init
 
       IF ( ((kt.GE.nit000_han).AND.(kt.LE.nitend_han)).AND. &
@@ -215,13 +196,8 @@
               DO ji = 1,jpi
                 ! Elevation
-                ana_temp(ji,jj,nhc,1) = ana_temp(ji,jj,nhc,1)                &
-                                        + ztemp*sshn(ji,jj)*tmask(ji,jj,1)        
+                ana_temp(ji,jj,nhc,1) = ana_temp(ji,jj,nhc,1) + ztemp*sshn(ji,jj)           *tmask(ji,jj,1)        
 #if defined key_dynspg_ts
-                ! ubar
-                ana_temp(ji,jj,nhc,2) = ana_temp(ji,jj,nhc,2)                &
-                                        + ztemp*un_b(ji,jj)*hur(ji,jj)*umask(ji,jj,1)
-                ! vbar
-                ana_temp(ji,jj,nhc,3) = ana_temp(ji,jj,nhc,3)                &
-                                        + ztemp*vn_b(ji,jj)*hvr(ji,jj)*vmask(ji,jj,1)
+                ana_temp(ji,jj,nhc,2) = ana_temp(ji,jj,nhc,2) + ztemp*un_b(ji,jj)*hur(ji,jj)*umask(ji,jj,1)
+                ana_temp(ji,jj,nhc,3) = ana_temp(ji,jj,nhc,3) + ztemp*vn_b(ji,jj)*hvr(ji,jj)*vmask(ji,jj,1)
 #endif
               END DO
@@ -233,5 +209,5 @@
       END IF
 
-      IF ( kt .EQ. nitend_han ) CALL dia_harm_end
+      IF ( kt == nitend_han )   CALL dia_harm_end
 
       IF( nn_timing == 1 )   CALL timing_stop('dia_harm')
@@ -239,8 +215,8 @@
    END SUBROUTINE dia_harm
 
+
    SUBROUTINE dia_harm_end
       !!----------------------------------------------------------------------
       !!                 ***  ROUTINE diaharm_end  ***
-      !!----------------------------------------------------------------------
       !!         
       !! ** Purpose :  Compute the Real and Imaginary part of tidal constituents
@@ -248,9 +224,5 @@
       !! ** Action  :  Decompose the signal on the harmonic constituents 
       !!
-      !! History :
-      !!   9.0  O. Le Galloudec and J. Chanut (Original)
-      !!--------------------------------------------------------------------
-
-      !! * Local declarations
+      !!--------------------------------------------------------------------
       INTEGER :: ji, jj, jh, jc, jn, nhan, jl
       INTEGER :: ksp, kun, keq
@@ -283,12 +255,11 @@
                nisparse(ksp) = keq
                njsparse(ksp) = kun
-               valuesparse(ksp)= &
-                   +(   MOD(jc,2) * ft(jh) * COS(ana_freq(jh)*ztime + vt(jh) + ut(jh)) &
-                   +(1.-MOD(jc,2))* ft(jh) * SIN(ana_freq(jh)*ztime + vt(jh) + ut(jh)))
+               valuesparse(ksp) = (   MOD(jc,2) * ft(jh) * COS(ana_freq(jh)*ztime + vt(jh) + ut(jh))   &
+                  &             + (1.-MOD(jc,2))* ft(jh) * SIN(ana_freq(jh)*ztime + vt(jh) + ut(jh)) )
             END DO
          END DO
       END DO
 
-      nsparse=ksp
+      nsparse = ksp
 
       ! Elevation:
@@ -296,11 +267,11 @@
          DO ji = 1, jpi
             ! Fill input array
-            kun=0
-            DO jh = 1,nb_ana
-               DO jc = 1,2
+            kun = 0
+            DO jh = 1, nb_ana
+               DO jc = 1, 2
                   kun = kun + 1
                   ztmp4(kun)=ana_temp(ji,jj,kun,1)
-               ENDDO
-            ENDDO
+               END DO
+            END DO
 
             CALL SUR_DETERMINE(jj)
@@ -314,15 +285,15 @@
       END DO
 
-      ALLOCATE(out_eta(jpi,jpj,2*nb_ana))
-      ALLOCATE(out_u  (jpi,jpj,2*nb_ana))
-      ALLOCATE(out_v  (jpi,jpj,2*nb_ana))
+      ALLOCATE( out_eta(jpi,jpj,2*nb_ana),   & 
+         &      out_u  (jpi,jpj,2*nb_ana),   &
+         &      out_v  (jpi,jpj,2*nb_ana)  )
 
       DO jj = 1, jpj
          DO ji = 1, jpi
             DO jh = 1, nb_ana 
-               X1=ana_amp(ji,jj,jh,1)
-               X2=-ana_amp(ji,jj,jh,2)
-               out_eta(ji,jj,jh)=X1 * tmask(ji,jj,1)
-               out_eta(ji,jj,nb_ana+jh)=X2 * tmask(ji,jj,1)
+               X1 = ana_amp(ji,jj,jh,1)
+               X2 =-ana_amp(ji,jj,jh,2)
+               out_eta(ji,jj,jh       ) = X1 * tmask(ji,jj,1)
+               out_eta(ji,jj,jh+nb_ana) = X2 * tmask(ji,jj,1)
             ENDDO
          ENDDO
@@ -402,17 +373,11 @@
    END SUBROUTINE dia_harm_end
 
+
    SUBROUTINE dia_wri_harm
       !!--------------------------------------------------------------------
       !!                 ***  ROUTINE dia_wri_harm  ***
-      !!--------------------------------------------------------------------
       !!         
       !! ** Purpose : Write tidal harmonic analysis results in a netcdf file
-      !!
-      !!
-      !! History :
-      !!   9.0  O. Le Galloudec and J. Chanut (Original)
-      !!--------------------------------------------------------------------
-
-      !! * Local declarations
+      !!--------------------------------------------------------------------
       CHARACTER(LEN=lc) :: cltext
       CHARACTER(LEN=lc) ::   &
@@ -472,10 +437,11 @@
 #else
       DO jh = 1, nb_ana
-      CALL iom_put( TRIM(tname(jh))//'x_v', out_u(:,:,jh) )
-      CALL iom_put( TRIM(tname(jh))//'y_v', out_u(:,:,nb_ana+jh) )
+         CALL iom_put( TRIM(tname(jh))//'x_v', out_u(:,:,jh       ) )
+         CALL iom_put( TRIM(tname(jh))//'y_v', out_u(:,:,jh+nb_ana) )
       END DO
 #endif
 
    END SUBROUTINE dia_wri_harm
+
 
    SUBROUTINE SUR_DETERMINE(init)
@@ -486,6 +452,6 @@
    !!       
    !!---------------------------------------------------------------------------------
-   INTEGER, INTENT(in) :: init 
-               
+   INTEGER, INTENT(in) ::   init 
+   !
    INTEGER                         :: ji_sd, jj_sd, ji1_sd, ji2_sd, jk1_sd, jk2_sd
    REAL(wp)                        :: zval1, zval2, zx1
@@ -496,27 +462,20 @@
    CALL wrk_alloc( jpincomax , ipos2 , ipivot        )
             
-   IF( init==1 )THEN
-
-      IF( nsparse .GT. jpdimsparse ) &
-         CALL ctl_stop( 'STOP', 'SUR_DETERMINE : nsparse .GT. jpdimsparse')
-
-      IF( ninco .GT. jpincomax ) &
-         CALL ctl_stop( 'STOP', 'SUR_DETERMINE : ninco .GT. jpincomax')
-
-      ztmp3(:,:)=0.e0
-
+   IF( init == 1 ) THEN
+      IF( nsparse > jpdimsparse )   CALL ctl_stop( 'STOP', 'SUR_DETERMINE : nsparse .GT. jpdimsparse')
+      IF( ninco   > jpincomax   )   CALL ctl_stop( 'STOP', 'SUR_DETERMINE : ninco .GT. jpincomax')
+      !
+      ztmp3(:,:) = 0._wp
+      !
       DO jk1_sd = 1, nsparse
          DO jk2_sd = 1, nsparse
-
-            nisparse(jk2_sd)=nisparse(jk2_sd)
-            njsparse(jk2_sd)=njsparse(jk2_sd)
-
+            nisparse(jk2_sd) = nisparse(jk2_sd)
+            njsparse(jk2_sd) = njsparse(jk2_sd)
             IF( nisparse(jk2_sd) == nisparse(jk1_sd) ) THEN
                ztmp3(njsparse(jk1_sd),njsparse(jk2_sd)) = ztmp3(njsparse(jk1_sd),njsparse(jk2_sd))  &
                                                         + valuesparse(jk1_sd)*valuesparse(jk2_sd)
             ENDIF
-
-         ENDDO
-      ENDDO
+         END DO
+      END DO
 
       DO jj_sd = 1 ,ninco
@@ -588,5 +547,4 @@
    ENDDO
 
-
    CALL wrk_dealloc( jpincomax , ztmpx , zcol1 , zcol2 )
    CALL wrk_dealloc( jpincomax , ipos2 , ipivot        )
@@ -594,5 +552,4 @@
   END SUBROUTINE SUR_DETERMINE
 
-
 #else
    !!----------------------------------------------------------------------
@@ -601,12 +558,10 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_diaharm = .FALSE.
 CONTAINS
-
    SUBROUTINE dia_harm ( kt )     ! Empty routine
       INTEGER, INTENT( IN ) :: kt  
       WRITE(*,*) 'dia_harm: you should not have seen this print'
    END SUBROUTINE dia_harm
-
-
-#endif
+#endif
+
    !!======================================================================
 END MODULE diaharm
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diahth.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diahth.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diahth.F90	(revision 4292)
@@ -304,9 +304,9 @@
       ! ----------------------------- !
 
-      ! find ilevel with (ilevel+1) the deepest W-level above 300m (we assume we can use e3t_0 to do this search...)
+      ! find ilevel with (ilevel+1) the deepest W-level above 300m (we assume we can use e3t_1d to do this search...)
       ilevel   = 0
       zthick_0 = 0._wp
       DO jk = 1, jpkm1                      
-         zthick_0 = zthick_0 + e3t_0(jk)
+         zthick_0 = zthick_0 + e3t_1d(jk)
          IF( zthick_0 < 300. )   ilevel = jk
       END DO
@@ -326,6 +326,4 @@
             htc3(ji,jj) = htc3(ji,jj) + tsn(ji,jj,ilevel+1,jp_tem) * MIN( fse3t(ji,jj,ilevel+1), zthick(ji,jj) )  &
                                                                    * tmask(ji,jj,ilevel+1)
-            htc3(ji,jj) = htc3(ji,jj) + tsn(ji,jj,ilevel+1,jp_tem) * MIN( fse3t(ji,jj,ilevel+1), zthick(ji,jj) )   &
-               &                                                   * tmask(ji,jj,ilevel+1)
          END DO
       END DO
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diaptr.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diaptr.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/DIA/diaptr.F90	(revision 4292)
@@ -259,4 +259,5 @@
       !
 #if defined key_mpp_mpi
+      ijpjjpk = jpj*jpk
       ish(1) = ijpjjpk  ;   ish2(1) = jpj   ;   ish2(2) = jpk
       zwork(1:ijpjjpk) = RESHAPE( p_fval, ish )
@@ -314,4 +315,5 @@
       END DO
 #if defined key_mpp_mpi
+      ijpjjpk = jpj*jpk
       ish(1) = jpj*jpk   ;   ish2(1) = jpj   ;   ish2(2) = jpk
       zwork(1:ijpjjpk)= RESHAPE( p_fval, ish )
@@ -670,9 +672,9 @@
             CALL histbeg(clhstnam, 1, zfoo, jpj, zphi,   &
                1, 1, 1, jpj, niter, zjulian, zdt*nn_fptr, nhoridz, numptr, domain_id=nidom_ptr)
-            ! Vertical grids : gdept_0, gdepw_0
+            ! Vertical grids : gdept_1d, gdepw_1d
             CALL histvert( numptr, "deptht", "Vertical T levels",   &
-               &                   "m", jpk, gdept_0, ndepidzt, "down" )
+               &                   "m", jpk, gdept_1d, ndepidzt, "down" )
             CALL histvert( numptr, "depthw", "Vertical W levels",   &
-               &                   "m", jpk, gdepw_0, ndepidzw, "down" )
+               &                   "m", jpk, gdepw_1d, ndepidzw, "down" )
             !
             CALL wheneq ( jpj*jpk, MIN(sjk(:,:,1), 1._wp), 1, 1., ndex  , ndim  )      ! Lat-Depth
